config/routes.rb
Rails.application.routes.draw do
  resources :products
  get 'welcome/index'

  root 'products#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/product.rb
class Product < ApplicationRecord
  mount_uploader :picture, PictureUploader

  validates :title, :price, presence: true

  validate :picture_size_validation

  def picture_size_validation
    errors[:picture] << "should be less than 100KB" if picture.size > 0.1.megabytes
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :version

  def version
    @version = `git rev-parse HEAD`
  end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]

  # GET /products
  # GET /products.json
  def index
    @products = Product.all.page(params[:page])
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        format.html { redirect_to @product, notice: 'Product was successfully created.' }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to @product, notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
    @product.destroy
    respond_to do |format|
      format.html { redirect_to products_url, notice: 'Product was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_product
    @product = Product.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def product_params
    params.require(:product).permit(:title, :price, :description, :picture)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/helpers/welcome_helper.rb
module WelcomeHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Demo</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div class="container">
      <%= yield %>
      <% if @version.present? %>
        <div class="app-version">
          <small>Version <%= @version %>
        </div>
      <% end %>
    </div>
  </body>
</html>

app/views/products/_form.html.erb
<%= form_with(model: product, local: true) do |form| %>
  <% if product.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(product.errors.count, "error") %> prohibited this product from being saved:</h2>

      <ul>
      <% product.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title, required: true %>
  </div>

  <div class="field">
    <%= form.label :price %>
    <%= form.number_field :price, required: true %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description, rows: 10, cols: 50 %>
  </div>

  <div class="field">
    <%= form.label :picture %>
    <%= form.file_field :picture %>
    <small>Max 100KB</small>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/products/edit.html.erb
<h1>Editing Product</h1>

<%= render 'form', product: @product %>

<%= link_to 'Show', @product %> |
<%= link_to 'Back', products_path %>

app/views/products/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Products</h1>


<%= link_to 'New Product', new_product_path, class: 'link-btn' %>

<br/>
<br/>

<table border="1" class="products">
  <thead>
    <tr>
      <th>Title</th>
      <th>Price</th>
      <th>Description</th>
      <th>Picture</th>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
      <tr>
        <td><%= link_to product.title, product %></td>
        <td><%= number_to_currency product.price %></td>
        <td><%= truncate product.description, length: 120 %></td>
        <td><%= image_tag(product.picture_url, height: 64) if product.picture? %></td>
        <td><%= link_to 'Edit', edit_product_path(product) %></td>
        <td><%= link_to 'Destroy', product, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<%= paginate @products %>

<br/>

<%= link_to 'New Product', new_product_path, class: 'link-btn' %>

app/views/products/new.html.erb
<h1>New Product</h1>

<%= render 'form', product: @product %>

<%= link_to 'Back', products_path %>

app/views/products/show.html.erb
<p id="notice"><%= notice %></p>

<h2><%= @product.title %></h2>

<hr/>

<h3>
  <strong>Price:</strong>
  <%= number_to_currency @product.price %>
</h3>

<div>
  <%= simple_format @product.description %>
</div>


<%- if @product.picture_url %>
  <div>
    <%= image_tag @product.picture_url %>
  </div>
<% end %>

<hr/>
<p>
Created at <%= @product.created_at %>
<br/>
Updated at <%= @product.updated_at %>
</p>

<%= link_to 'Edit', edit_product_path(@product) %> |
<%= link_to 'Back', products_path %>